"""
Django settings for nsp project.

Generated by 'django-admin startproject' using Django 4.1.7.

For more information on this file, see
https://docs.djangoproject.com/en/4.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.1/ref/settings/
"""

from dotenv import load_dotenv
from pathlib import Path
import nsp.logging
import logging.config
import os
import json

SECURE_CROSS_ORIGIN_OPENER_POLICY = None


# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

load_dotenv(os.path.join(BASE_DIR, ".env"))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.1/howto/deployment/checklist/

JOBS_WORKERS = int(os.environ.get("JOBS_WORKERS", "4"))

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get(
    "SECRET_KEY_BASE",
    "django-insecure-dh03e&85shn5oz5sq&z5bwbf^nvhow21%o_wh6!+x!byk7i&yy",
)
ENVIRONMENT = os.environ.get("ENVIRONMENT")
# SECURITY WARNING: don't run with debug turned on in production!
if ENVIRONMENT == "development":
    DEBUG = True
    SALT_DEV_CMD_PREFIX = os.environ.get("SALT_DEV_CMD_PREFIX", "docker exec nsp ")
else:
    DEBUG = False
    SALT_DEV_CMD_PREFIX = os.environ.get("SALT_DEV_CMD_PREFIX", "docker exec nsp ")
   # SALT_DEV_CMD_PREFIX = ""

ALLOWED_HOSTS = ["*"]

# Application definition

INSTALLED_APPS = [
    "daphne",
    "channels_postgres",
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "django_extensions",
    "django_prometheus",
    "django_apscheduler",
    "api",
    "jobs",
    "home",
    "login",
    "dashboards",
    "devices",
    "networks",
    "settings",
    "rest_framework",
    "rest_framework.authtoken",
    "drf_yasg",
]

MIDDLEWARE = [
    "django_prometheus.middleware.PrometheusBeforeMiddleware",
    "django.middleware.security.SecurityMiddleware",
    "whitenoise.middleware.WhiteNoiseMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    # "utils.middleware.LogRequestHeaders",
    "django_prometheus.middleware.PrometheusAfterMiddleware",
]

ROOT_URLCONF = "nsp.urls"

TEMPLATES_DIR = os.path.join(BASE_DIR, "templates")

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [TEMPLATES_DIR],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
            ],
        },
    },
]

WSGI_APPLICATION = "nsp.wsgi.application"

# netbox variables used for client and manage.py mocknetbox command
NB_URL = os.environ.get("NB_URL", "http://localhost:8080")
NB_TOKEN = os.environ.get("NB_TOKEN", "0123456789abcdef0123456789abcdef01234567")
NB_TAGS = os.getenv("NB_TAGS", "name:icon_switch,slug:icon_switch,description:switch")
NB_TAGS = dict(
    map(str.strip, sub.split(":", 1)) for sub in NB_TAGS.split(",") if ":" in sub
)
NB_DEVICE_ROLES = os.getenv(
    "NB_DEVICE_ROLES",
    "firewall,router,distribution-switch,core-switch,internal-switch,access-switch,server,storage,backup",
)
NB_DEVICE_ROLES = NB_DEVICE_ROLES.split(",")
NB_DEVICE_TYPES = os.getenv("NB_DEVICE_TYPES", "spine,leaf,border")
NB_DEVICE_TYPES = NB_DEVICE_TYPES.split(",")
NB_DEVICE_USERNAME = os.getenv("NB_DEVICE_USERNAME", "admin")
NB_DEVICE_PASSWORD = os.getenv("NB_DEVICE_PASSWORD", "admin")

NB_MANUFACTURERS = os.getenv("NB_MANUFACTURERS", "edgecore,dell,nvidia")
NB_MANUFACTURERS = NB_MANUFACTURERS.split(",")
NB_MODELS = os.getenv("NB_MODELS", "AS4630,S5232,S5248,SN2010")
NB_MODELS = NB_MODELS.split(",")
NB_INITIAL_SITE = os.getenv("NB_INITIAL_SITE", "LM_Test_Site")

NB_PLATFORMS = os.getenv("NB_PLATFORMS", "sonic")
NB_PLATFORMS = NB_PLATFORMS.split(",")
NB_nsp_NETWORKS = os.getenv("NB_nsp_NETWORKS", "pdc,kdc,mta,osn-lab").split(",")
NB_CUSTOM_FIELDS = json.loads(
    os.getenv(
        "NB_CUSTOM_FIELDS",
        '[{"name":"nsp_network","content_types":["dcim.device","tenancy.tenant"],"type":"text"}]',
    )
)

NB_DEVICE_MAP = {
    "spine01": {
        "serial": "spine01",
        "platform": {"slug": NB_PLATFORMS[0]},
        "device_type": {"slug": NB_DEVICE_TYPES[0]},
        "device_role": {"slug": NB_DEVICE_ROLES[3]},
        "site": {"slug": NB_INITIAL_SITE},
        "tenant": {"slug": NB_INITIAL_SITE},
        "custom_fields": {"nsp_network": NB_nsp_NETWORKS[3]},
    },
    "spine02": {
        "serial": "spine02",
        "platform": {"slug": NB_PLATFORMS[0]},
        "device_type": {"slug": NB_DEVICE_TYPES[0]},
        "device_role": {"slug": NB_DEVICE_ROLES[3]},
        "site": {"slug": NB_INITIAL_SITE},
        "tenant": {"slug": NB_INITIAL_SITE},
        "custom_fields": {"nsp_network": NB_nsp_NETWORKS[3]},
    },
    "leaf01": {
        "serial": "leaf01",
        "platform": {"slug": NB_PLATFORMS[0]},
        "device_type": {"slug": NB_DEVICE_TYPES[1]},
        "device_role": {"slug": NB_DEVICE_ROLES[5]},
        "site": {"slug": NB_INITIAL_SITE},
        "tenant": {"slug": NB_INITIAL_SITE},
        "custom_fields": {"nsp_network": NB_nsp_NETWORKS[3]},
    },
    "leaf02": {
        "serial": "leaf02",
        "platform": {"slug": NB_PLATFORMS[0]},
        "device_type": {"slug": NB_DEVICE_TYPES[1]},
        "device_role": {"slug": NB_DEVICE_ROLES[5]},
        "site": {"slug": NB_INITIAL_SITE},
        "tenant": {"slug": NB_INITIAL_SITE},
        "custom_fields": {"nsp_network": NB_nsp_NETWORKS[3]},
    },
    "leaf03": {
        "serial": "leaf03",
        "platform": {"slug": NB_PLATFORMS[0]},
        "device_type": {"slug": NB_DEVICE_TYPES[1]},
        "device_role": {"slug": NB_DEVICE_ROLES[5]},
        "site": {"slug": NB_INITIAL_SITE},
        "tenant": {"slug": NB_INITIAL_SITE},
        "custom_fields": {"nsp_network": NB_nsp_NETWORKS[3]},
    },
    "leaf04": {
        "serial": "leaf04",
        "platform": {"slug": NB_PLATFORMS[0]},
        "device_type": {"slug": NB_DEVICE_TYPES[1]},
        "device_role": {"slug": NB_DEVICE_ROLES[5]},
        "site": {"slug": NB_INITIAL_SITE},
        "tenant": {"slug": NB_INITIAL_SITE},
        "custom_fields": {"nsp_network": NB_nsp_NETWORKS[3]},
    },
    # "leaf05": {
    #     "serial": "leaf05",
    #     "platform": {"slug": NB_PLATFORMS[0]},
    #     "device_type": {"slug": NB_DEVICE_TYPES[1]},
    #     "device_role": {"slug": NB_DEVICE_ROLES[5]},
    #     "site": {"slug": NB_INITIAL_SITE},
    #     "tenant": {"slug": NB_INITIAL_SITE},
    #     "custom_fields": {"nsp_network": NB_nsp_NETWORKS[3]},
    # },
    # "leaf06": {
    #     "serial": "leaf06",
    #     "platform": {"slug": NB_PLATFORMS[0]},
    #     "device_type": {"slug": NB_DEVICE_TYPES[1]},
    #     "device_role": {"slug": NB_DEVICE_ROLES[5]},
    #     "site": {"slug": NB_INITIAL_SITE},
    #     "tenant": {"slug": NB_INITIAL_SITE},
    #     "custom_fields": {"nsp_network": NB_nsp_NETWORKS[3]},
    # },
}

NB_CIRCUIT_PROVIDER_NAME = os.getenv("NB_CIRCUIT_PROVIDER_NAME", "AiCloud")
NB_CIRCUIT_PROVIDER_ASN = os.getenv("NB_CIRCUIT_PROVIDER_ASN", "64512")
NB_CIRCUIT_PROVIDER_ACCOUNT = os.getenv("NB_CIRCUIT_PROVIDER_ACCOUNT", "1234")
NB_CIRCUIT_PROVIDER_PORTAL_URL = os.getenv(
    "NB_CIRCUIT_PROVIDER_PORTAL_URL", "https://www.x.com"
)
NB_CIRCUIT_PROVIDER_NOC_CONTACT = os.getenv(
    "NB_CIRCUIT_PROVIDER_NOC_CONTACT", "keith.birdsall@aicloud.guru"
)
NB_CIRCUIT_PROVIDER_COMMENTS = os.getenv("NB_CIRCUIT_PROVIDER_COMMENTS", "test")

# Database
# https://docs.djangoproject.com/en/4.1/ref/settings/#databases
DB_NAME = os.environ.get("DB_NAME", "nsp")
DB_USER = os.environ.get("DB_USER", "postgres")
DB_PASSWORD = os.environ.get("DB_PASSWORD", "postgres")
DB_HOST = os.environ.get("DB_HOST", "localhost")
DB_PORT = os.environ.get("DB_PORT", "5433")

# DATABASE_URL = f"postgresql://{DB_USER}:{DB_PASSWORD}@{DB_HOST}:{DB_PORT}/{DB_NAME}"

DATABASES = {
    "default": {
        "ENGINE": "django_prometheus.db.backends.postgresql",
        "NAME": DB_NAME,
        "USER": DB_USER,
        "PASSWORD": DB_PASSWORD,
        "HOST": DB_HOST,
        "PORT": DB_PORT,
    },
    "channels_postgres": {
        "ENGINE": "django.db.backends.postgresql_psycopg2",
        "NAME": DB_NAME,
        "USER": DB_USER,
        "PASSWORD": DB_PASSWORD,
        "HOST": DB_HOST,
        "PORT": DB_PORT,
    },
}

# Password validation
# https://docs.djangoproject.com/en/4.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.1/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = os.environ.get("TZ", "UTC")

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.1/howto/static-files/

STATIC_URL = "/static/"

STATIC_ROOT = os.path.join(BASE_DIR, "staticfiles")

# Allow media files to be uploaded into the app
MEDIA_URL = '/media/'
MEDIA_ROOT = os.path.join(BASE_DIR, 'media')

# Default primary key field type
# https://docs.djangoproject.com/en/4.1/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"

LOGLEVEL = os.environ.get("LOGLEVEL", "INFO")

logging.config.dictConfig(
    {
        "version": 1,
        "disable_existing_loggers": False,
        "formatters": {
            "console": {
                "()": nsp.logging.LogfmtFormatter,
            }
        },
        "handlers": {
            "console": {
                "class": "logging.StreamHandler",
                "formatter": "console",
            }
        },
        "loggers": {
            "urllib3.connectionpool": {
                "handlers": ["console"],
            },
            "django.server": {
                "handlers": ["console"],
            },
            "uvicorn.access": {
                "handlers": ["console"],
            },
            "uvicorn.error": {
                "handlers": ["console"],
            },
            "uvicorn": {
                "handlers": ["console"],
            },
            "gunicorn.access": {
                "handlers": ["console"],
            },
            "gunicorn.error": {
                "handlers": ["console"],
            },
        },
        "root": {
            "handlers": ["console"],
            "level": LOGLEVEL,
        },
    }
)

ASGI_APPLICATION = "nsp.asgi.application"

REST_FRAMEWORK = {
    "DEFAULT_PAGINATION_CLASS": "rest_framework.pagination.PageNumberPagination",
    "DEFAULT_SCHEMA_CLASS": "rest_framework.schemas.openapi.AutoSchema",
    "PAGE_SIZE": 10,
    "DEFAULT_AUTHENTICATION_CLASSES": [
        "rest_framework.authentication.SessionAuthentication",
        "rest_framework.authentication.TokenAuthentication",
    ],
}

SWAGGER_SETTINGS = {
    "VALIDATOR_URL": None,
    "DEFAULT_INFO": "nsp.urls.openapi_info",
    "SECURITY_DEFINITIONS": {
        "Token": {"type": "apiKey", "name": "Authorization", "in": "header"},
    },
}

SCHEDULER_CONFIG = {
    "apscheduler.jobstores.default": {
        "class": "django_apscheduler.jobstores:DjangoJobStore"
    },
    "apscheduler.executors.processpool": {"type": "threadpool"},
}

SCHEDULER_AUTOSTART = os.getenv("SCHEDULER_AUTOSTART", "False").lower() in (
    "true",
    "1",
    "t",
)

NETBOX_INVENTORY_PLUGIN = os.getenv("NETBOX_INVENTORY_PLUGIN", "False").lower() in (
    "true",
    "1",
    "t",
)

CHANNEL_LAYERS = {
    "default": {
        "BACKEND": "channels_postgres.core.PostgresChannelLayer",
        "CONFIG": {
            "ENGINE": "django.db.backends.postgresql_psycopg2",
            "NAME": DB_NAME,
            "USER": DB_USER,
            "PASSWORD": DB_PASSWORD,
            "HOST": DB_HOST,
            "PORT": DB_PORT,
        },
    },
}

LOGIN_REDIRECT_URL = "/"
LOGIN_URL = "/login/"
LOGOUT_REDIRECT_URL = "/login/"
